#!/system/bin/sh

echo "####################################################";
echo "Welecom to user leelen update software!";
echo "Version number: V1.0.0_20160831";
echo "Applicative equipment: V3SL-FJV32011";
echo "###################################################";

config_path="/mnt/disk/config/config"
configback_path="/mnt/disk/backup/config"

success()
{
	echo "###########################################";
	echo "successfully update";
	echo "###########################################";
}

update_1()
{
	if [ -e /tmp/$1 ]; then
		if [ -e $2$1 ]; then
			echo "begin update $1";
      			mv  /tmp/$1   $2new_$1;
			echo "$2$1" > /mnt/New.txt;
			rm -r $2$1;
			mv $2new_$1 $2$1;
			echo "" > /mnt/New.txt;
       		echo "update $1 successfully";
		else
			echo "$2$1 not found";
			echo "begin update $1";
      			mv  /tmp/$1   $2;
			echo "update $1 successfully";
       	fi			
	else
		echo "$1 not found";
	fi
	sync;
}

update_2()
{
	if [ -e /tmp/$1 ]; then
		if [ -e $2$1 ]; then
			cd /tmp/;
			name=$(ls $1);
			echo "begin update $name";
      			cp  /tmp/$name   $2new_$name;
			echo "$2$name" > /mnt/New.txt;
			rm -r $2$1;
			cp $2new_$name $2$name;
			rm -r $2new_$name;
			rm -r /tmp/$name;
			echo "" > /mnt/New.txt;
       		echo "update $name successfully";
		else
			echo "$2$1 not found";
			echo "begin update $1";
      			cp  /tmp/$1   $2;
      			rm  /tmp/$1;
			echo "update $1 successfully";
       	fi			
	else
		echo "$1 not found";
	fi
	sync;
}

update_3()
{
	if [ -e /tmp/$1 ]; then
		if [ -e $2$1 ]; then
			echo "begin update $1";
      			cp  /tmp/$1   $2new_$1;
			echo "$2$1" > /mnt/New.txt;
			rm -r $2$1;
			mv $2new_$1 $2$1;
			echo "" > /mnt/New.txt;
       		echo "update $1 successfully";
		else
			echo "$2$1 not found";
			echo "begin update $1";
      			cp  /tmp/$1   $2;
			echo "update $1 successfully";
       	fi			
	else
		echo "$1 not found";
	fi
	sync;
}
update_4()
{
	if [ -e /tmp/$1 ]; then
		if [ -e $2$1 ]; then
			echo "begin update $1";
      			cp  /tmp/$1   $2new_$1;
			echo "$2$1" > /mnt/New.txt;
			rm -r $2$1;
			cp $2new_$1 $2$1;
			rm -r $2new_$1;
			rm -r /tmp/$1;
			echo "" > /mnt/New.txt;
       		echo "update $1 successfully";
		else
			echo "$2$1 not found";
			echo "begin update $1";
      			cp  /tmp/$1   $2;
      			rm -r /tmp/$1;
			echo "update $1 successfully";
       	fi			
	else
		echo "$1 not found";
	fi
	sync;
}


rename()
{
	if [ -e /tmp/$1* ]; then
		mv  /tmp/$1* /tmp/$1;
	else
		echo " /tmp/$1* not found";
	fi
}

kill_process()
{
	PROCESS_NAME=$1
	PROCESS_INFO=$(ps|grep $PROCESS_NAME)
	echo "kill process:"$PROCESS_NAME ${PROCESS_INFO:10:6}
	kill -9 ${PROCESS_INFO:10:6}
}

kill_process_ppid()
{
	PROCESS_NAME=$1
	PROCESS_INFO=$(ps|grep $PROCESS_NAME)
	echo "kill process ppid:"$PROCESS_NAME ${PROCESS_INFO:15:6}
	kill -9 ${PROCESS_INFO:15:6}
}

#Establish New.txt
echo "Establish New.txt";
if [ -e /mnt/New.txt ]; then
	echo "" > /mnt/New.txt;
else
	touch /mnt/New.txt;
fi

#showpic
/tmp/jpgshow &
sleep 2

echo 'lcd'>/sys/kernel/debug/dispdbg/name
echo 'enable'>/sys/kernel/debug/dispdbg/command
echo '1'>/sys/kernel/debug/dispdbg/start

echo 'lcd'>/sys/kernel/debug/dispdbg/name
echo 'setbl'>/sys/kernel/debug/dispdbg/command
echo '200'>/sys/kernel/debug/dispdbg/param
echo '1'>/sys/kernel/debug/dispdbg/start

#kill other 
kill_process_ppid ddcloud_sdk_250170412
kill_process ddcloud_sdk_250170412
kill_process wifitester
kill_process wpa_supplicant
kill_process jpgshow

#burn Kernel
if [ -e /tmp/boot.fex ]; then
	echo "begin update Kernel";
	cd /tmp/;
	./flash_erase /dev/mtd/mtd1 0 0;
  dd if=/tmp/boot.fex of=/dev/mtd/mtd1;
	echo "update Kernel successful";      
else
	echo "Kernel not found";
fi

#burn bootloader
if [ -e /tmp/mtd0.fex ]; then
	echo "begin update bootloader";
	cd /tmp/;
	./flash_erase /dev/mtd/mtd0 0 0;
  dd if=/tmp/mtd0.fex of=/dev/mtd/mtd0;
	echo "burn bootloader successful";      
else
	echo "bootloader not found";
fi

#burn system
if [ -e /tmp/rootfs.fex ]; then
	echo "begin update system";
	cd /tmp/;
	./flash_erase /dev/mtd/mtd2 0 0
  dd if=/tmp/rootfs.fex of=/dev/mtd/mtd2;
	echo "burn system successful";      
else
	echo "system not found";
fi

cd /tmp
i=0;
while ((i<7))
do
	hour_end="time_slot_hour_end$i=24"
	new_hour_end="time_slot_hour_end$i=23"
	minute_end="time_slot_minute_end$i=00"
	new_minute_end="time_slot_minute_end$i=59"
	if grep $hour_end $config_path; then
		./busybox-armv7m sed -i "s/$hour_end/$new_hour_end/g" $config_path
		if grep $minute_end $config_path; then
			./busybox-armv7m sed -i "s/$minute_end/$new_minute_end/g" $config_path
		fi
	else
		echo "$hour_end config!seq 24";
	fi
	if grep $hour_end $configback_path; then
		./busybox-armv7m sed -i "s/$hour_end/$new_hour_end/g" $configback_path
		if grep $minute_end $configback_path; then
			./busybox-armv7m sed -i "s/$minute_end/$new_minute_end/g" $configback_path
		fi
	else
		echo "$hour_end back upconfig!seq 24";
	fi
	((i++))
done

i=0;
while ((i<7))
do
	hour_start="time_slot_hour_start$i=24"
	new_hour_start="time_slot_hour_start$i=23"
	minute_start="time_slot_minute_start$i=00"
	new_minute_start="time_slot_minute_start$i=59"
	if grep $hour_start $config_path; then
		./busybox-armv7m sed -i "s/$hour_start/$new_hour_start/g" $config_path
		if grep $minute_start $config_path; then
			./busybox-armv7m sed -i "s/$minute_start/$new_minute_start/g" $config_path
		fi
	else
		echo "$hour_start config!seq 24";
	fi
	if grep $hour_start $configback_path; then
		./busybox-armv7m sed -i "s/$hour_start/$new_hour_start/g" $configback_path
		if grep $minute_start $configback_path; then
			./busybox-armv7m sed -i "s/$minute_start/$new_minute_start/g" $configback_path
		fi
	else
		echo "$hour_start backup config!seq 24";
	fi
	((i++))
done

rm -r /mnt/disk/wav/startleave.wav
rm -r /mnt/disk/wav/en_startleave.wav
rm -r /mnt/disk/wav/it_startleave.wav
rm -rf /tmp/boa
mv /tmp/new_boa /tmp/boa
update_2 "boa"         				"/mnt/disk/boa/";
update_2 "en_IsLeaveMessage.wav"             "/mnt/disk/wav/";
update_2 "it_IsLeaveMessage.wav"             "/mnt/disk/wav/";
update_2 "DoorOpenTimeout.wav"             	 "/mnt/disk/wav/";
update_2 "cardLimited.wav"             	 	 "/mnt/disk/wav/";
update_2 "config.cgi"             			"/mnt/disk/boa/cgi-bin/";
update_2 "save.cgi"             			"/mnt/disk/boa/cgi-bin/";
update_2 "upload.cgi"           			"/mnt/disk/boa/cgi-bin/";
update_2 "call.cgi"           			"/mnt/disk/boa/cgi-bin/";
update_2 "ave_config.cgi"          			"/mnt/disk/boa/cgi-bin/";
update_2 "ave_card_name_modify.cgi"		"/mnt/disk/boa/cgi-bin/";
update_2 "ave_card_record.cgi"		"/mnt/disk/boa/cgi-bin/";
update_2 "ave_unlock_record.cgi"		"/mnt/disk/boa/cgi-bin/";
update_2 "ave_upload.cgi"		"/mnt/disk/boa/cgi-bin/";


update_2 "linphonerc"         "/mnt/disk/";
update_2 "main_*"             "/mnt/disk/";
update_2 "config"                           "/mnt/disk/configbackup/";


#Delete New.txt
echo "Delete New.txt";
rm -r /mnt/New.txt;

/mnt/disk/killall -10 upload.cgi

sleep 2;
reboot;

success;

exit 0;
